unit Unit1; 

// WInFF 0.3 Copyright 2006-2007 Matthew Weatherford
// http://biggmatt.com
// Licensed under the GPL v3 or any later version


{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  {$IFDEF WIN32} windows, shellapi, dos,{$endif}
  {$IFDEF unix} baseunix, unix, {$endif}
  laz_xmlcfg, dom, xmlread, xmlwrite, StdCtrls, Buttons, ActnList, Menus, unit2, unit3,
  unit4, unit5;

type

  { TForm1 }

  TForm1 = class(TForm)
    AddBtn: TBitBtn;
    optionsbtn: TBitBtn;
    StartBtn: TBitBtn;
    Play: TBitBtn;
    ClearBtn: TBitBtn;
    RemoveBtn: TBitBtn;
    CheckBox2: TCheckBox;
    pass2: TCheckBox;
    CheckBox1: TCheckBox;
    Label9: TLabel;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    importmenu: TMenuItem;
    showoptions: TMenuItem;
    Viewmenu: TMenuItem;
    filemenu: TMenuItem;
    ChooseFolderBtn: TButton;
    DestFolder: TEdit;
    Aspectratio: TEdit;
    audbitrate: TEdit;
    audsamplingrate: TEdit;
    commandlineparams: TEdit;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    VidsizeX: TEdit;
    Label4: TLabel;
    Vidframerate: TEdit;
    Label3: TLabel;
    Vidbitrate: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    PresetBox: TComboBox;
    filelist: TListBox;
    VidsizeY: TEdit;
    procedure AspectratioChange(Sender: TObject);
    procedure ChooseFolderBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure ExitmenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure importmenuClick(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure PlayClick(Sender: TObject);
    procedure RemoveBtnClick(Sender: TObject);
    function GetDeskTopPath() : string;
    function GetMydocumentsPath() : string ;
    procedure setconfigvalue(key:string;value:string);
    function getconfigvalue(key:string):string;
    procedure populatepresetbox();
    function getcurrentpresetname():string;
    function getpresetparams(presetname:string):string;
    function getpresetextension(presetname:string):string;
    procedure showoptionsClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure importpresetfromfile(presetfilename: string);
    function GetappdataPath() : string ;


  private
    { private declarations }

  public
    { public declarations }

  end; 


{$IFDEF WIN32}
const
  shfolder = 'ShFolder.dll';
  CSIDL_PERSONAL: longint = $0005;
  CSIDL_DESKTOPDIRECTORY: longint = $0010;
  CSIDL_APPDATA: longint = $001a;
{$ENDIF}

var
  Form1: TForm1; 
  exePath: string;
  {$IFDEF WIN32}
  PIDL : PItemIDList;
  {$ENDIF}
  lastpreset: string;
  presetsfile: Txmldocument;
  presetspath: string;
  configpath: string;
  presets: tdomnode;
  ffmpeg: string;
  ffplay: string;
  terminal: string;
  termoptions: string;
  rememberlast: string;
  insertpoint: string;
  showopts: string;
  rememberpreset: string;
  pass2encoding: string ;
  pausescript: string;
  multithreading: string;
implementation


// Initialize everything
procedure tform1.FormCreate(Sender: TObject);
var
f1,f2:textfile;
ch: char;
i:integer;
importfromcmdline: string;
begin
  ExePath:= ExtractFilePath(ParamStr(0));

  {$IFDEF WIN32}
  presetspath :=GetappdataPath() + '\Winff\';

  if not DirectoryExists(presetspath) then
    createdir(presetspath);

  if not fileexists(presetspath + 'presets.xml') then
     begin
      AssignFile(F1, exepath + '\presets.xml');
      Reset(F1);
      AssignFile(F2, presetspath + 'presets.xml');
      Rewrite(F2);
      while not Eof(F1) do
        begin
          Read(F1, Ch);
          Write(F2, Ch);
        end;
      CloseFile(F2);
      CloseFile(F1);
     end;

  ffmpeg := getconfigvalue('win32/ffmpeg');
  if ffmpeg = '' then
     begin
       ffmpeg := exepath + 'ffmpeg.exe';
       setconfigvalue('win32/ffmpeg',ffmpeg);
     end;

  ffplay := getconfigvalue('win32/ffplay');
   if ffplay = '' then
     begin
       ffplay := exepath + 'ffplay.exe';
       setconfigvalue('win32/ffplay',ffplay);
     end;

  terminal := 'cmd.exe';
  termoptions := '/c';


  {$endif}

  {$IFDEF UNIX}
  presetspath := GetMydocumentsPath() + '/.winff/';
  if not DirectoryExists(presetspath) then
    createdir(presetspath);

  if not fileexists(presetspath + 'presets.xml') then
     begin
      AssignFile(F1, '/usr/share/winff/presets.xml');
      Reset(F1);
      AssignFile(F2, presetspath + 'presets.xml');
      Rewrite(F2);
      while not Eof(F1) do
        begin
          Read(F1, Ch);
          Write(F2, Ch);
        end;
      CloseFile(F2);
      CloseFile(F1);
     end;
     
  ffmpeg := getconfigvalue('unix/ffmpeg');
  if ffmpeg = '' then
     begin
       ffmpeg := '/usr/bin/ffmpeg';
       if not fileexists(ffmpeg) then
         if fileexists('/usr/local/bin/ffmpeg') then
            ffmpeg := '/usr/local/bin/ffmpeg'
         else
            showmessage('could not find ffmpeg');
       setconfigvalue('unix/ffmpeg',ffmpeg)
     end;
     
  ffplay := getconfigvalue('unix/ffplay');
  if ffplay = '' then
     begin
       ffplay := '/usr/bin/ffplay';
       if not fileexists(ffplay) then
         if fileexists('/usr/local/bin/ffplay') then
            ffmpeg := '/usr/local/bin/ffplay'
         else
            showmessage('could not find ffplay');
       setconfigvalue('unix/ffplay',ffplay);
     end;
     
  terminal := getconfigvalue('unix/terminal');
  if terminal = '' then
     begin
       terminal := '/usr/bin/xterm';
       setconfigvalue('unix/terminal',terminal);
     end;
     
  termoptions := getconfigvalue('unix/termoptions');
  if termoptions = '' then
     begin
       termoptions := '-e';
       setconfigvalue('unix/termoptions',termoptions);
     end;
  {$ENDIF}

  destfolder.text := getconfigvalue('general/destfolder');   // get destination folder
  if destfolder.text='' then DestFolder.Text:= getmydocumentspath();
  rememberlast := getconfigvalue('general/rememberlast');
  if rememberlast='' then
    begin
     rememberlast:= 'true';
     setconfigvalue('general/rememberlast',rememberlast);
    end;

  presetsfile.Create;                         // load the presets file
  try
   ReadXMLFile(presetsfile, presetspath+'presets.xml');
   presets:=presetsfile.DocumentElement;
  except
  end;
                                      // import preset from command line
  if paramstr(1) <> '' then
   begin
   importfromcmdline := paramstr(1);
   {$IFDEF WIN32}
   importfromcmdline := FExpand(importfromcmdline);
   {$ENDIF}
    importpresetfromfile(paramstr(1));
   end;
  
  populatepresetbox();        // fill combobox with presets
  rememberpreset:=getconfigvalue('general/currentpreset');
  for i:= 0 to  presetbox.items.Count - 1 do
    begin
     if presetbox.Items[i]=rememberpreset then
        begin
        presetbox.ItemIndex:=i;
        break;
        end;
    end;
                                          // check menu's
  showopts:=getconfigvalue('general/showoptions');
  if showopts='' then showopts:='false';
  if showopts='true' then
        begin
        form1.Height:=461;
        groupbox1.Top:=264;
        groupbox1.Visible:=true;
        groupbox2.top:=376;
        groupbox2.Visible:=true;
        showoptions.Checked:=true;
        form1.invalidate;
        end
  else
        begin
        form1.Height:=290;
        groupbox1.Top:=264;
        groupbox1.Visible:=false;
        groupbox2.top:=264;
        groupbox2.Visible:=false;
        showoptions.Checked:=false;
        form1.invalidate;
        end;
                                       // check 2 pass encoding
  pass2encoding:=getconfigvalue('general/pass2');
  if pass2encoding='' then pass2.checked:=false;
  if pass2encoding='true' then pass2.checked:=true;
  
                                      // check pause before finished
  pausescript:=getconfigvalue('general/pause');

                                        // check for multithreading
  multithreading:=getconfigvalue('general/multithreading');


end;

// clean up and shut down
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var
s:string;
begin
  if rememberlast = 'true' then   // save destination folder
     setconfigvalue('general/destfolder',destfolder.text);

  s := presetbox.text;   // save default preset
  if s <> '' then setconfigvalue('general/currentpreset',s);

  if showoptions.Checked then // save show options
     setconfigvalue('general/showoptions','true')
  else
     setconfigvalue('general/showoptions','false');
     
  if pass2.Checked then // save 2 pass
     setconfigvalue('general/pass2','true')
  else
     setconfigvalue('general/pass2','false');

  presetsfile.Free;           // cleanup

end;

// keep width on resize
procedure TForm1.FormResize(Sender: TObject);
begin
  form1.Width:=515;
end;

// get the params from the preset
function tform1.getpresetparams(presetname:string):string;
var
paramnode : tdomnode;
param:string;
begin
   try
    if presets.FindNode(presetname).FindNode('params').HasChildNodes then
    begin
      paramnode:=presets.FindNode(presetname).FindNode('params').FindNode('#text');
      param:=paramnode.NodeValue;
    end
   except
    param:='';
   end;
   result:=param;
end;

// get the extension of the preset
function tform1.getpresetextension(presetname:string):string;
begin
   result:=presets.FindNode(presetname).FindNode('extension').FindNode('#text').NodeValue;
end;

// get the name of the selected preset
function tform1.getcurrentpresetname():string;
var
i:integer;
node,subnode: tdomnode;
begin
   for i:= 0 to presets.childnodes.count -1 do
   begin
     node := presets.childnodes.item[i];
     subnode:= node.FindNode('label');
     if presetbox.text = subnode.findnode('#text').nodevalue then
       result := node.nodename;
   end;
end;

// clear and load the preset box with current list
procedure tform1.populatepresetbox();
var
i:integer;
node,subnode : tdomnode;
begin
   presetbox.Clear;
   for i:= 0 to presets.ChildNodes.Count -1  do
   begin
    node:= presets.ChildNodes.item[i];
    subnode:= node.FindNode('label');
    presetbox.items.add(subnode.findnode('#text').NodeValue);
    presetbox.sorted:=true;
    presetbox.sorted:=false;
   end;
end;

// set a value in the config file
procedure TForm1.setconfigvalue(key:string;value:string);
var
cfg: TXMLConfig;
begin
 cfg := TXMLConfig.create(presetspath+'cfg.xml');
 cfg.SetValue(key,value);
 cfg.free;
end;

// get a value from the config file
function TForm1.getconfigvalue(key:string): string;
var
cfg: TXMLConfig;
begin
 cfg := TXMLConfig.create(presetspath+'cfg.xml');
 result := cfg.GetValue(key, '');
 cfg.free;
end;

// get the user's desktop path
function tform1.GetDeskTopPath() : string ;
{$ifdef win32}
var
  ppidl: PItemIdList;
begin
  ppidl := nil;
  SHGetSpecialFolderLocation(Form1.Handle,CSIDL_DESKTOPDIRECTORY , ppidl);
  SetLength(Result, MAX_PATH);
   if not SHGetPathFromIDList(ppidl, PChar(Result)) then
        raise exception.create('SHGetPathFromIDList failed : invalid pidl');
   SetLength(Result, lStrLen(PChar(Result)));
end;
{$endif}
{$ifdef unix}
begin
 result := GetEnvironmentVariable('HOME') + DirectorySeparator  + 'Desktop';
end;
{$endif}

// get the user's document's path
function tform1.GetMydocumentsPath() : string ;
{$ifdef win32}
var
  ppidl: PItemIdList;
begin
  ppidl := nil;
  SHGetSpecialFolderLocation(Form1.Handle,CSIDL_PERSONAL , ppidl);
  SetLength(Result, MAX_PATH);
   if not SHGetPathFromIDList(ppidl, PChar(Result)) then
        raise exception.create('SHGetPathFromIDList failed : invalid pidl');
   SetLength(Result, lStrLen(PChar(Result)));
end;
{$endif}
{$ifdef unix}
begin
 result := GetEnvironmentVariable('HOME') ;
end;
{$endif}

// get the user's application data path
function tform1.GetappdataPath() : string ;
{$ifdef win32}
var
  ppidl: PItemIdList;
begin
  ppidl := nil;
  SHGetSpecialFolderLocation(Form1.Handle,CSIDL_APPDATA , ppidl);
  SetLength(Result, MAX_PATH);
   if not SHGetPathFromIDList(ppidl, PChar(Result)) then
        raise exception.create('SHGetPathFromIDList failed : invalid pidl');
   SetLength(Result, lStrLen(PChar(Result)));
end;
{$endif}
{$ifdef unix}
begin
 result := GetEnvironmentVariable('HOME') ;
end;
{$endif}


// choose a folder
procedure TForm1.ChooseFolderBtnClick(Sender: TObject);
begin
  SelectDirectoryDialog1.execute;
  DestFolder.Text := SelectDirectoryDialog1.FileName;
end;

procedure TForm1.AspectratioChange(Sender: TObject);
begin

end;


// add files to the list
procedure tform1.AddBtnClick(Sender: TObject);
begin
   Opendialog1.Title:='Select Video Files';
   Opendialog1.InitialDir := getconfigvalue('general/addfilesfolder');
   OpenDialog1.Execute;
   setconfigvalue('general/addfilesfolder',opendialog1.InitialDir);
   filelist.items.AddStrings(OpenDialog1.Files);
end;

// remove a file from the list
procedure tform1.RemoveBtnClick(Sender: TObject);
var
i: integer;
begin
  i:=0;
  while i< filelist.Items.Count do
    if filelist.Selected[i] then
      filelist.Items.Delete(i)
    else
       i+=1;
end;

// clear the file list
procedure tform1.ClearBtnClick(Sender: TObject);
begin
  filelist.Clear;
end;

procedure TForm1.ExitmenuClick(Sender: TObject);
begin

end;


// menu: edit the presets
procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  form2.show;
end;

// menu: edit preferences
procedure TForm1.MenuItem5Click(Sender: TObject);
begin
form4.show;
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin

end;

// menu: about
procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  form3.show;
end;

// menu: exit the program
procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  form1.close;
end;

// menu: import preset
procedure TForm1.importmenuClick(Sender: TObject);
begin
  OpenDialog1.Title:='Select Preset File';
  if OpenDialog1.Execute then
      importpresetfromfile(opendialog1.FileName);

end;

// menu: show / hide additional options
procedure TForm1.showoptionsClick(Sender: TObject);
 begin
   if not showoptions.Checked then
        begin
        form1.Height:=461;
        groupbox1.Top:=264;
        groupbox1.Visible:=true;
        groupbox2.top:=376;
        groupbox2.Visible:=true;
        showoptions.Checked:=true;
        form1.invalidate;
        end
  else
        begin
        form1.Height:=290;
        groupbox1.Top:=264;
        groupbox1.Visible:=false;
        groupbox2.top:=264;
        groupbox2.Visible:=false;
        showoptions.Checked:=false;
        form1.invalidate;
        vidbitrate.Clear;
        vidframerate.clear;
        aspectratio.Clear;
        audbitrate.Clear;
        audsamplingrate.Clear;
        vidsizex.Clear;
        vidsizey.clear;
        checkbox1.Checked:=false;
        commandlineparams.Clear;
        end;
end;

// play the selected file
procedure TForm1.PlayClick(Sender: TObject);
var
selecteditem,i : integer;
ffplayfilename,filenametoplay: string;
begin
 {$ifdef win32}ffplayfilename:='"' + ffplay + '"';{$endif}

 if not fileexists(ffplay) then
   begin
    showmessage('ffplay could not be found.');
    exit;
   end;

 if filelist.Items.Count = 1 then
    filelist.Selected[0]:=true;

 i:=0;
 while i< filelist.Items.Count do
    if filelist.Selected[i] then
      begin
      filenametoplay:=filelist.Items[i];
      break;
      end
    else i+=1;

 if filenametoplay <>'' then
    sysutils.ExecuteProcess(ffplay, '"' + filenametoplay+'"' );

end;


// Start Conversions
procedure TForm1.StartBtnClick(Sender: TObject);
var
i,j : integer;
pn, extension, params, commandline, command, filename,batfile, passlogfile, basename: string;
qterm, ffmpegfilename, usethreads, deinterlace, nullfile, titlestring: string;
script: tstringlist;
thetime: tdatetime;
begin                                     // get setup
   script:= TStringList.Create;
   {$ifdef win32}ffmpegfilename:='"' + ffmpeg + '"';{$endif}
   {$ifdef unix}ffmpegfilename:=ffmpeg;{$endif}

   {$ifdef win32}nullfile:='"NUL.avi"';{$endif}
   {$ifdef unix}nullfile:='/dev/null';{$endif}

   
   if multithreading='true' then usethreads := ' -threads 2'
    else usethreads:='';
   
   if checkbox2.Checked then deinterlace := ' -deinterlace '
    else deinterlace:='';
   
   if not fileexists(ffmpeg) then
      begin
       showmessage('ffmpeg could not be found.');
       exit;
      end;

   pn:=getcurrentpresetname();
   if pn='' then
      begin
       showmessage('Please select a preset');
       exit;
      end;
   if filelist.Items.Count=0 then
      begin
       showmessage('Please add at least 1 file to convert');
       exit;
      end;
   params:=getpresetparams(pn);
   extension:=getpresetextension(pn);
   unit5.form5.memo1.lines.Clear;

                                         // trim everything up
   commandlineparams.text := trim(commandlineparams.Text);
   vidbitrate.Text := trim(vidbitrate.Text);
   vidframerate.text := trim(vidframerate.Text);
   VidsizeX.text := trim(VidsizeX.Text);
   aspectratio.Text := trim(aspectratio.text);
   audbitrate.Text := trim(audbitrate.Text);
   audsamplingrate.Text := trim(audsamplingrate.Text);

   commandline := params;
   if vidbitrate.Text <> '' then
      commandline += ' -b ' + vidbitrate.text+'kb';
   if vidframerate.Text <> '' then
      commandline += ' -r ' + vidframerate.Text;
   if (VidsizeX.Text <>'') AND (VidsizeY.Text <>'') then
      commandline += ' -s ' + VidsizeX.Text + 'x' + VidsizeY.Text;
   if aspectratio.Text <> '' then
      commandline += ' -aspect ' + aspectratio.Text;
   if audbitrate.Text <> '' then
      commandline += ' -ab ' + audbitrate.Text;
   if audsamplingrate.Text <> '' then
      commandline += ' -ar ' + audsamplingrate.Text;
   if commandlineparams.Text <> '' then
      commandline += ' ' + commandlineparams.text;


                                           // build batch file
   thetime :=now;
   batfile := 'ff' + FormatDateTime('yymmddhhnnss',thetime) +
           {$ifdef win32}'.bat'{$endif}
           {$ifdef unix}'.sh'{$endif} ;

   for i:=0 to filelist.Items.Count - 1 do
     begin
       filename := filelist.items[i];
       basename := extractfilename(filename);
       for j:= length(basename) downto 1  do
         begin
           if basename[j] = #46 then
              begin
                basename := leftstr(basename,j-1);
                break;
              end;
         end;

       command := '';
       {$ifdef win32}titlestring:='title Converting ' + extractfilename(filename);{$endif}
       {$ifdef unix}titlestring:='echo -n "\033]0; Converting ' + extractfilename(filename)+'\007"';{$endif}
       script.Add(titlestring);
       
       passlogfile := destfolder.Text + DirectorySeparator + basename + '.log';

       if pass2.Checked = false then
          begin
           command := ffmpegfilename + usethreads + ' -i "' + filename + '" ' + deinterlace + commandline + ' "' +
                  destfolder.Text + DirectorySeparator + basename +'.' + extension+ '"';
           script.Add(command);
          end
       else if pass2.Checked = true then
          begin
           command := ffmpegfilename + usethreads + ' -i "' + filename + '" ' + deinterlace + commandline  + ' -passlogfile "'
                 + passlogfile + '"' + ' -pass 1 ' +  ' -y ' + nullfile ;
           script.Add(command);
           command := ffmpegfilename + usethreads + ' -y -i "' + filename + '" ' + deinterlace + commandline +  ' -passlogfile "'
                 + passlogfile + '"' + ' -pass 2 ' + ' "' + destfolder.Text + DirectorySeparator + basename +'.'
                 + extension+ '"';
           script.add(command);
          end;

     end;
                                                        // finish off commandline

   if pausescript='true' then
       {$ifdef win32}
       script.Add('pause');
       {$endif}
       {$ifdef unix}
       script.Add('read -p "Press Enter to continue" dumbyvar');
       {$endif}

   {$ifdef win32}script.Add('del ' + presetspath + batfile);{$endif}
   {$ifdef unix}script.Add('rm ' + presetspath + batfile);{$endif}

   if not checkbox1.Checked then
    begin
     script.SaveToFile(presetspath+batfile);
     {$ifdef unix}
     fpchmod(presetspath + batfile,&777);
     {$endif}

     {$ifdef win32}qterm := '"' + terminal + '"';{$endif}
     {$ifdef unix}qterm := terminal;{$endif}
                                                        // do it
     {$ifdef win32}winexec(pchar( qterm + ' ' + termoptions + ' "' + presetspath + batfile + '"'), SW_SHOWNORMAL);{$endif}
     {$ifdef unix}shell(qterm + ' ' +  termoptions + ' ' + presetspath + batfile + ' &'); {$endif}
    end
   else
    begin
      unit5.Form5.Memo1.Lines:=script;
      unit5.Form5.Show;
    end;

    script.Free;
end;


// import a preset from a file
procedure tform1.importpresetfromfile(presetfilename: string);
var
 importfile: txmldocument;
 importedpreset: tdomelement;
 i:integer;
 newnode,labelnode,paramsnode,extensionnode,
  textl,textp,texte, node,subnode: tdomnode;
 nodename,nodelabel,nodeparams,nodeext, testchars:string;
begin
 if not fileexists(presetfilename) then
    begin
      showmessage('file does not exist');
      exit;
    end;

 try
  importfile := TXMLdocument.Create;
 except
 end;

 try
   ReadXMLFile(importfile, presetFileName);
   importedpreset:=importfile.DocumentElement;
 except
  showmessage('Invalid Preset File');
  exit;
 end;

 if importedpreset.ChildNodes.Count = 0 then exit;

 node:= importedpreset.FirstChild;

 nodename:= node.NodeName;

 for i:= 0 to presets.ChildNodes.Count -1 do
   if presets.ChildNodes.Item[i].NodeName = nodename then
      begin
       showmessage('Preset: "'+nodename+'" already exists');
       exit;
      end;

 try
   nodelabel := node.FindNode('label').FindNode('#text').NodeValue;
 except
   begin
     showmessage('The preset to import does not have a label');
     exit;
   end;
 end;

 try
   testchars := node.FindNode('params').FindNode('#text').NodeValue;
 except
 end;
 for i:= 0 to length(testchars)-1 do
   begin
     if (testchars[i] = #124) or (testchars[i] = #60) or (testchars[i] = #62) or
        (testchars[i] = #59) or (testchars[i] = #38) then
       begin
        showmessage('The preset params contain illegal characters and maybe malicious');
        exit;
       end;
   end;


 for i:= 0 to presets.ChildNodes.Count -1 do
   if presets.ChildNodes.Item[i].findnode('label').FindNode('#text').NodeValue = nodelabel then
      begin
       showmessage('Preset with label: "'+nodelabel+'" already exists');
       exit;
      end;


 try
   nodeext := node.FindNode('extension').FindNode('#text').NodeValue;
 except
   begin
     showmessage('The preset to import does not have an extension');
     exit;
   end;
 end;

 newnode:=presetsfile.CreateElement(nodename);
 presets.AppendChild(newnode);
 labelnode:=presetsfile.CreateElement('label');
 newnode.AppendChild(labelnode);
 paramsnode:=presetsfile.CreateElement('params');
 newnode.AppendChild(paramsnode);
 extensionnode:=presetsfile.CreateElement('extension');
 newnode.AppendChild(extensionnode);

 textl:=presetsfile.CreateTextNode(nodelabel);
 labelnode.AppendChild(textl);

 try
 textp:=presetsfile.CreateTextNode(node.FindNode('params').FindNode('#text').NodeValue);
 except
 textp:=presetsfile.CreateTextNode('');
 end;
 paramsnode.AppendChild(textp);

 texte:=presetsfile.CreateTextNode(nodeext);
 extensionnode.AppendChild(texte);

writexmlfile(presetsfile, presetspath + 'presets.xml');  // save the imported preset

populatepresetbox();
end;

initialization
  {$I unit1.lrs}

end.

