unit Unit4; 

// WInFF 0.3 Copyright 2006-2007 Matthew Weatherford
// http://biggmatt.com
// Licensed under the GPL v3 or any later version

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  ExtCtrls, StdCtrls;

type

  { TForm4 }

  TForm4 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Notebook1: TNotebook;
    OpenDialog1: TOpenDialog;
    Page1: TPage;
    Page2: TPage;
    Page3: TPage;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form4: TForm4; 

implementation

uses unit1;
{ TForm4 }

// load preferences
procedure TForm4.FormCreate(Sender: TObject);

begin
  {$ifdef win32}
   page3.tabVisible:=false;
   edit2.Text:= form1.getconfigvalue('win32/ffmpeg');
   edit3.Text:= form1.getconfigvalue('win32/ffplay');
  {$endif}
  {$ifdef unix}
   page2.tabvisible:=false;
   edit4.Text:= form1.getconfigvalue('unix/ffmpeg');
   edit5.Text:= form1.getconfigvalue('unix/ffplay');
   edit6.Text:= form1.getconfigvalue('unix/terminal');
   edit7.Text:= form1.getconfigvalue('unix/termoptions');
  {$endif}

  edit1.Text:= form1.getconfigvalue('general/destfolder');


  if form1.getconfigvalue('general/rememberlast') = 'true' then
     checkbox1.Checked := true
  else
     checkbox1.Checked := false;

  if form1.getconfigvalue('general/pause') = 'true' then
     checkbox2.Checked := true
  else
     checkbox2.Checked := false;

  if form1.getconfigvalue('general/multithreading') = 'true' then
     checkbox3.Checked := true
  else
     checkbox3.Checked := false;
end;

// save preference
procedure TForm4.Button1Click(Sender: TObject);
var
ipoint:string;

begin
  form1.setconfigvalue('general/destfolder',edit1.text);
  form1.DestFolder.Text := edit1.text;
  
  if checkbox1.Checked then
   begin
    form1.setconfigvalue('general/rememberlast','true');
    unit1.rememberlast:='true';
   end
  else
   begin
    form1.setconfigvalue('general/rememberlast','false');
    unit1.rememberlast:='false';
   end;

  if checkbox2.Checked then
   begin
    form1.setconfigvalue('general/pause','true');
    unit1.pausescript:='true';
   end
  else
   begin
    form1.setconfigvalue('general/pause','false');
    unit1.pausescript:='false';
   end;

  if checkbox3.Checked then
   begin
    form1.setconfigvalue('general/multithreading','true');
    unit1.multithreading:='true';
   end
  else
   begin
    form1.setconfigvalue('general/multithreading','false');
    unit1.multithreading:='false';
   end;


  edit1.Text := trim(edit1.Text);
  edit2.Text := trim(edit2.Text);
  edit3.Text := trim(edit3.Text);
  edit4.Text := trim(edit4.Text);
  edit5.Text := trim(edit5.Text);
  edit6.Text := trim(edit6.Text);
  edit7.Text := trim(edit7.Text);

  {$ifdef win32}
  if edit2.Text ='' then
   edit2.Text := unit1.exePath + 'ffmpeg.exe';
  if edit3.Text ='' then
   edit3.Text := unit1.exePath + 'ffplay.exe';

  unit1.ffmpeg := edit2.text;
  unit1.ffplay := edit3.text;
  form1.setconfigvalue('win32/ffmpeg',edit2.text);
  form1.setconfigvalue('win32/ffplay',edit3.text);
  {$endif}

  {$ifdef unix}
  if edit4.Text ='' then
   edit4.Text := '/usr/bin/ffmpeg';
  if edit5.Text ='' then
   edit5.Text := '/usr/bin/ffplay';
  if edit6.Text ='' then
   edit6.Text := '/usr/bin/xterm';

  unit1.ffmpeg := edit4.text;
  unit1.ffplay := edit5.text;
  unit1.terminal :=edit6.text;
  unit1.termoptions := edit7.text;
  form1.setconfigvalue('unix/ffmpeg',edit4.text);
  form1.setconfigvalue('unix/ffplay',edit5.text);
  form1.setconfigvalue('unix/terminal',edit6.text);
  form1.setconfigvalue('unix/termoptions',edit7.text);
  {$endif}
  

  form4.close;

end;

procedure TForm4.Button3Click(Sender: TObject);
begin
 if selectdirectorydialog1.Execute then
    edit1.Text := selectdirectorydialog1.FileName;
end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  form4.close;
end;

procedure TForm4.Button4Click(Sender: TObject);
begin
  if opendialog1.Execute then
    edit2.Text := opendialog1.FileName;
end;

procedure TForm4.Button5Click(Sender: TObject);
begin
   if opendialog1.Execute then
    edit3.Text := opendialog1.FileName;
end;

procedure TForm4.Button6Click(Sender: TObject);
begin
  if opendialog1.Execute then
    edit4.Text := opendialog1.FileName;
end;

procedure TForm4.Button7Click(Sender: TObject);
begin
  if opendialog1.Execute then
    edit5.Text := opendialog1.FileName;
end;

procedure TForm4.Button8Click(Sender: TObject);
begin
   if opendialog1.Execute then
    edit6.Text := opendialog1.FileName;
end;

procedure TForm4.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin

end;

initialization
  {$I unit4.lrs}

end.

